/*
 * abasic
 * Copyright (C) 2007 m_inaba
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#if !defined(__ABASIC_)
#define __ABASIC_

#include "./common.h"
#include "./calc.h"
#include "./vari.h"
#include "./variant.h"
#include "./variant_io.h"
#include "./st_inst.h"
#include "./buff.h"



#define EVAL			0x80000000
#define IF				0x20000000

//MAX 0xFF ʂɂ荶8Vtg
#define NOTHING			0x01

#define WHILE			0x10
#define WEND			0x11
#define BREAK			0x12
#define FOR				0x13
#define NEXT			0x14
#define GOTO			0x15
#define FUNC			0x16
#define RETURN			0x17
#define INPUT			0x18
#define OUTPUT			0x19
#define PRINT			0x1A
#define CLR				0x1B
#define LOCATION		0x1C
#define SLEEP			0x1D
#define ABS				0x1E
#define INT				0x1F
#define SHELL			0x20
#define LEN				0x21
#define MID				0x22
#define VAL				0x23
#define STR				0x24
#define CSV				0x25
#define CHOP			0x26
#define SPLIT			0x27
#define REPLACE			0x28
#define MATCH			0x29
#define VSC				0x2A
#define ABASIC_FREAD	0x2B
#define ABASIC_FWRITE	0x2C
#define IF2				0x2D
#define ELSE			0x2E
#define ENDIF			0x2F
#define TRIM			0x30
#define LTRIM			0x31
#define RTRIM			0x32
#define LCASE			0x33
#define UCASE			0x34
#define LEFT			0x35
#define RIGHT			0x36
#define JIS				0x37
#define ASC				0x38
#define INSTR			0x39
#define BLOCK_			0x3A
#define _BLOCK			0x3B
#define FORMAT			0x3C
#define HEX				0x3D
#define XEH				0x3E
#define OCT				0x3F
#define TCO				0x40
#define BIN				0x41
#define NIB				0x42
#define ABASIC_FOPEN	0x43
#define ABASIC_FINPUT	0x44
#define ABASIC_FOUTPUT	0x45
#define ABASIC_FCLOSE	0x46

//lZ----------------------
#define SQRT			0xA1
#define _EXP			0xA2
#define LOG10			0xA3
#define LOG				0xA4
#define SIN				0xA5
#define COS				0xA6
#define TAN				0xA7
#define ASIN			0xA8
#define ACOS			0xA9
#define ATAN			0xAA
//------------------------------
#define EXP				0xFE
#define MASK			0xFF


extern unsigned int p_counter; //vOJE^
extern std::map<std::string,std::string> variable_table;//̃}bv
extern std::vector<std::string> source; //basic̃vOi[z

int basic_init(char*filename);
void basic_setup();
void basic_start(int);
void basic_end();

void source_init();
void source_add(const char*str,int line);
void source_end();

#endif

//-------------------------------------------------------------------------------
